/* -*- mode: c; coding: utf-8 -*- */
/* $Id$ */

#define NEED_CORR 1
#include "checker.h"

#include <errno.h>

int checker_main(int argc, char **argv)
{
  char *txt, *eptr;;
  size_t txtsz;
  unsigned char *s;
  unsigned char *p;
  int i = 0, j = 0;
  double user_val, corr_val;

  // preprocess the user answer
  checker_read_file(1, &txt, &txtsz);
  s = (unsigned char *) txt;
  p = xmalloc(txtsz + 1);
  for (i = 0; i < txtsz; ++i) {
    if (s[i] == ',') {
      p[j++] = '.';
    } else if (s[i] > ' ' && s[i] != 127) {
      p[j++] = s[i];
    }
  }
  p[j] = 0;
  if (!j) fatal_PE("Введен пустой ответ");
  errno = 0;
  user_val = strtod(p, &eptr);
  if (errno || *eptr) fatal_PE("Ответ не является числом");

  checker_read_corr_double("corr_answer", 1, &corr_val);
  if (!checker_eq_double(user_val, corr_val, 1e-8))
    fatal_WA("Неправильный ответ");

  checker_OK();
}
